#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <Application.h>
#include <Window.h>
#include <Alert.h>

#include "Sanity.h"
#include "ScannerWindow.h"

#include "BeSANE.h"

const char * APPLICATION_SIGNATURE = "application/x-vnd." SOFTWARE_EDITOR "-" SOFTWARE_NAME;

const char * STR_ABOUT_TITLE =	"About " SOFTWARE_NAME;
const char * STR_ABOUT_BUTTON =	"Big Deal";	// "Hum?"
const char * STR_ABOUT_TEXT = 	SOFTWARE_NAME " " SOFTWARE_VERSION_LABEL "\n" \
								"A little BeSANE front-end.\n\n" \
								"The " SOFTWARE_NAME " Team:\n\n" \
								"Philippe Houdoin\n" \
								"Cedric Degea\n" \
								"Cedric Vincent\n" \
								"\n" \
								"Thanks to:\n" \
								"Chrystelle\n" \
								"BeSANE team\n"
								"Be Inc.\n" \
								"Internet\n" \
								"Life\n";

// --------------------------------------------------------------
int main()
{
	// Create an application instance
	Application * app;

	app = new Application();
	app->Run();
	delete app;
	
	return 0;
}



// --------------------------------------------------------------
Application::Application()
	: BApplication(APPLICATION_SIGNATURE)
{
	window_rect.Set(50, 50, 400, 500);
	windows_count = 0;
	
	sane_init(0, NULL);
}



// -------------------------------------------------
Application::~Application()
{
	sane_exit();

}


// -------------------------------------------------
void Application::ReadyToRun( void )
{
	// Open at least one window!
	if ( windows_count < 1 )
		PostMessage(NEW_WINDOW_MSG);
}
	
	
// --------------------------------------------------------------
void Application::MessageReceived
	(
	BMessage * pMsg
	)
{
	switch( pMsg->what ) 
		{
		case NEW_WINDOW_MSG:
			{
			ScannerWindow * window = new ScannerWindow(window_rect);
			window->Show();

			window_rect.OffsetBy(40, 40);
			windows_count++;
			break;
			};
			
		case WINDOW_CLOSED_MSG:
			{
			windows_count--;
			if ( windows_count < 1 )
				PostMessage(B_QUIT_REQUESTED);
			break;
			};
			
		default:
			inherited::MessageReceived( pMsg );
			break;
		};
}


// --------------------------------------------------------------
void Application::RefsReceived
	(
	BMessage *	msg
	) 
{ 
	switch (msg->what) 
		{
		default:
			inherited::MessageReceived(msg);
			break;
		};
}


// -------------------------------------------------
void Application::AboutRequested( void )
{
	BAlert * about_box;
	
	about_box = new BAlert(STR_ABOUT_TITLE, STR_ABOUT_TEXT, STR_ABOUT_BUTTON);
	about_box->Go();
}

