#ifndef SCANNEROPTIONVIEW_H
#define SCANNEROPTIONVIEW_H

#include <InterfaceKit.h>

#include "BeSANE.h"


class ScannerOptionView : public BView  
{
	public:
		// Constructors, destructors, operators...
		ScannerOptionView(BRect frame, const char * name, uint32 resizeMask, uint32 flags, SANE_Handle device, int opt_number);
		~ScannerOptionView();
							
		typedef BView 			inherited;

		typedef enum {
			UNKNOWN = 0,
			STRING,
			NUMERIC,
			NUMERIC_RANGE,
			NUMERIC_ARRAY,
			STRING_LIST,
			NUMERIC_LIST,
			PATH,
			COMMAND,
			BOOLEAN
		} field_type; 

		// public constantes
		enum	{
			BROWSE_FILE_MSG		= 'brwf',
			BROWSE_DIR_MSG		= 'brwd',
			SET_VALUE_MSG		= 'setv',
			RELOAD_MSG			= 'rloa'
		};

		// Virtual function overrides
	public:
		virtual status_t			Build(void);
		virtual void 				AttachedToWindow(void);
		virtual void				MessageReceived(BMessage * msg);
		virtual field_type			Type() 							{ return m_type; };
		virtual void				SetEnabled(bool on);
		virtual bool				IsEnabled(void) const			{ return m_enabled; };

		SANE_Handle					Device() 						{ return m_device; };
		int							Option()						{ return m_opt; };
		
		
		// From here, it's none of your business! ;-)
	private:
		uint32							m_flags;
		
		SANE_Handle						m_device;
		int								m_opt;
		const SANE_Option_Descriptor *	m_desc;
		bool							m_enabled;
		field_type						m_type;
};

#endif // ifdef SCANNEROPTIONVIEW_H

