#ifndef SCANNERWINDOW_H
#define SCANNERWINDOW_H

#include <Window.h>

#include "BeSANE.h"

class BitmapView;
class ToolTip;
class OptionsListView;
class TranslatorSavePanel;

// THE window class
class ScannerWindow : public BWindow  
{
	public:
		// Constructors, destructors, operators...
								ScannerWindow(BRect Frame);
								~ScannerWindow();
							
		typedef BWindow 		inherited;


		// public constantes
		enum	{
			SAVE_AS_MSG			= 'sava',
			SAVE_FILE_PANEL_MSG	= 'sfpm',
			SET_DEVICE_MSG		= 'sdev',
			DEVICE_LIST_MSG		= 'devl',
			SCAN_MSG 			= 'scan',
			UPDATED_IMAGE_MSG	= 'uimg'
		};
				
		// Virtual function overrides
	public:	
		virtual void			MessageReceived(BMessage * msg);
		virtual	bool			QuitRequested(void);
		
		status_t				SetImage(BBitmap * bitmap);

		virtual int32			DevicesRosterThread();
		virtual int32			ScanThread();

		SANE_Handle				Device() 						{ return m_device; };
		
		// From here, it's none of your business! ;-)
	private:
		static	int32			_DevicesRosterThread(void * p) { return ((ScannerWindow *) p)->DevicesRosterThread(); }
		thread_id				m_devices_roster_thread_id;

		static	int32			_ScanThread(void * p) { return ((ScannerWindow *) p)->ScanThread(); }
		thread_id				m_scan_thread_id;
		volatile bool			m_cancel_scan;

		SANE_Handle				m_device;
		const SANE_Device *		m_device_info;

		BBox *					m_panel;
		BitmapView *			m_bitmap_view;
		ToolTip *				m_tooltip;
		BBitmap *				m_image;
		BMenuField * 			m_devices_field;
		BPopUpMenu * 			m_devices_menu;
		BStatusBar *			m_status_bar;
		BButton *				m_scan_button;
		BScrollView *			m_options_sv;
		OptionsListView *		m_options_lv;

		TranslatorSavePanel *	m_save_panel;
};

#endif // ifdef SCANNERWINDOW_H

